#ifndef mapKeyClass_H_INCLUDED
#define mapKeyClass_H_INCLUDED

#include "tss2/tss2_esys.h"

struct MapKey {
    UINT32 identifier; // something better?
    TPMI_ALG_HASH hash;
    UINT32 pcrNumber;

    MapKey(UINT32 identifier, TPMI_ALG_HASH hash, UINT32 pcrNumber)
    {
        this->identifier=identifier;
        this->hash=hash;
        this->pcrNumber=pcrNumber;
    }

    bool operator==(const MapKey &other) const
    {
        return (identifier==other.identifier && hash == other.hash && pcrNumber == other.pcrNumber);
    };
};

namespace std
{
    template<>
    struct hash<MapKey>
    {
        size_t operator()(const MapKey& mk) const{
            return (mk.identifier)^(mk.pcrNumber);
        }
    };
}

/*
std::ostream& operator << (std::ostream& strm, const MapKey& m){
    strm << "MapKey(" << m.identifier << "," << m.pcrNumber << ")";
    return strm;
};*/

#endif