#ifndef structure_H_INCLUDED
#define structure_H_INCLUDED

#include "tss2/tss2_tcti_mssim.h"
#include "tss2/tss2_esys.h"
#include <iostream>

struct Key {
    ESYS_TR keyHandle;
    TPM2B_PUBLIC *outPublic;
    TPM2B_PRIVATE *outPrivate;
    TPM2B_CREATION_DATA *creationData;
    TPM2B_DIGEST *creationHash;
    TPMT_TK_CREATION *creationTicket;
};

struct IntegrityRequest
{
	TPM2B_DATA nonce;
	TPML_PCR_SELECTION pcrSelection;
};

struct IntegrityReport
{
	TPM2B_ATTEST attestStructure_VM;
	TPMT_SIGNATURE signatureStructure_VM;
	TPML_DIGEST pcrValues_VM;

	TPM2B_ATTEST attestStructure_VMM;
	TPMT_SIGNATURE signatureStructure_VMM;
	TPML_DIGEST pcrValues_VMM;
};

#endif