#ifndef verifier_H_INCLUDED
#define verifier_H_INCLUDED

#include "tss2/tss2_esys.h"
#include "structure.h"

class Verifier
{
	public:
		Verifier(UINT32 id);
		~Verifier();

		//Function for the creation of the Integrity Request
		IntegrityRequest CreateIntegrityRequest();

		// Function for Integrity Report Evaluation
		void VerifyIntegrityReport(IntegrityReport integrityReport, Key rootKey, Key aik);

	private:
	        // Method to initialize the TCTI context
	        void Init_Tcti_Tabrmd_Context();
	        
	        // Method to finalize the TCTI context
	        void Finalize_Tcti_Tabrmd_Context();

	        // Methods to initialize the ESYS context
	        void Init_Esys_Context();

	        // Method to finalize the ESYS context
	        void Finalize_Esys_Context();

	        int ErrorHandling(TSS2_RC rc);
		// This is a unique id 
	    UINT32 identifier;

	private:
        // Pointers to contexts
        TSS2_TCTI_CONTEXT *tcti_context = nullptr;
        ESYS_CONTEXT      *esys_context = nullptr;
};
#endif